<?php
/**
*
* @package phpBB3 Football
* @version $Id: rank_total.php 1 2010-05-17 22:09:43Z football $
* @copyright (c) 2010 football (http://football.bplaced.net)
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

if ( !defined('IN_PHPBB') OR !defined('IN_FOOTBALL') )
{
	exit;
}

if ($matchday == $maxmatchday)
{
	$win_user_most_hits = win_user_most_hits($season, $league,$matchday);
	$win_user_most_hits_away = win_user_most_hits_away($season, $league,$matchday);
	$season_wins = season_wins($season, $league, $matchday);
}

$sql = 'SELECT
			r.user_id,
			u.username,
			MIN(r.status) AS status_min,
			SUM(points) AS points,
			SUM(win) AS wins_total
		FROM '. FOOTB_RANKS . ' AS r
		LEFT JOIN '. USERS_TABLE . " AS u ON (r.user_id = u.user_id)
		WHERE r.season = $season 
			AND r.league = $league 
			AND r.matchday <= $matchday 
			AND r.status IN (2,3)
		GROUP BY user_id
		ORDER BY points DESC, user_id ASC";
$result = $db->sql_query($sql);

$ranking_arr = array();
while( $row = $db->sql_fetchrow($result))
{
	$ranking_arr[$row['user_id']] = $row;
}
$db->sql_freeresult($result);

if ( sizeof($ranking_arr) > 0 )
{
	if ($matchday == $maxmatchday)
	{
		$sql = 'SELECT
					eb.user_id,
					SUM(eb.bet_points) AS points
				FROM  ' . FOOTB_EXTRA . ' AS e
				INNER JOIN ' . FOOTB_EXTRA_BETS . " AS eb ON (eb.season = e.season and eb.league = e.league and eb.extra_no = e.extra_no)
				WHERE e.matchday <> $matchday 
					AND e.matchday_eval = $matchday 
					AND e.extra_status > 1
				GROUP BY eb.user_id"; 
		
		$result = $db->sql_query($sql);
		while( $row = $db->sql_fetchrow($result))
		{
			$ranking_arr[$row['user_id']]['points'] += $row['points'];
		}
		$db->sql_freeresult($result);
	}
	// sort the ranking by points
	usort($ranking_arr, '_sort_points');
}

$index = 0;
$data_rank_total = false;
$last_rank = 0;
$last_points = -1;
foreach( $ranking_arr AS $curr_user => $curr_rank)
{
	$index++;
	$data_rank_total = true;
	if ( $curr_rank['points'] == $last_points)
	{
		$rank = $last_rank;
	}
	else
	{
		$rank = $index;
		$last_points = $curr_rank['points'];
		$last_rank = $rank;
	}
	if (($rank <= $config['football_display_ranks']) OR ($curr_rank['user_id'] == $user->data['user_id']))
	{
		if ($matchday == $maxmatchday)
		{
			// if someone didn't bet the hole Season
			if(!isset($win_user_most_hits[$curr_rank['user_id']]["Win"]))
			{
				$win_user_most_hits[$curr_rank['user_id']]["Win"] = 0;
			}
			if(!isset($win_user_most_hits_away[$curr_rank['user_id']]["Win"]))
			{
				$win_user_most_hits_away[$curr_rank['user_id']]["Win"] = 0;
			}
			if(!isset($season_wins[$curr_rank['user_id']]["Win"]))
			{
				$season_wins[$curr_rank['user_id']]["Win"] = 0;
			}
			$ranking_arr[$curr_user]['wins_total'] = sprintf('%01.2f',$curr_rank['wins_total'] + $win_user_most_hits[$curr_rank['user_id']]["Win"] + $win_user_most_hits_away[$curr_rank['user_id']]["Win"] + $season_wins[$curr_rank['user_id']]["Win"]);
		}
		else
		{
			$ranking_arr[$curr_user]['wins_total']  = sprintf('%01.2f',$curr_rank['wins_total']);
		}
		$row_class = (!($index % 2)) ? 'bg1 row_light' : 'bg2 row_dark';
		if ($curr_rank['user_id'] == $user->data['user_id'])
		{
			$row_class = 'bg3  row_user';
		}
		$colorstyle = color_style($curr_rank['status_min']);

		$template->assign_block_vars("ranktotal", array(
			'RANK' 			=> $rank,
			'ROW_CLASS' 	=> $row_class,
			'USERID' 		=> $curr_rank['user_id'],
			'USERNAME' 		=> $curr_rank['username'],
			'URL' 			=> $phpbb_root_path . "profile.php?mode=viewprofile&u=" . $curr_rank['user_id'],
			'POINTS' 		=> $curr_rank['points'],
			'COLOR_STYLE'	=> $colorstyle,
			'WIN' 			=> $curr_rank['wins_total'] ,
			)
		);
	}
}
$db->sql_freeresult($result);
$league_info = league_info($season, $league);

$template->assign_vars(array(
	'S_DISPLAY_RANK_TOTAL' 	=> true,
	'S_DATA_RANK_TOTAL' 	=> $data_rank_total,
	'S_WIN' 				=> ($league_info['win_matchday'] == '0' and $league_info['win_season'] == '0') ? false : true,
	)
);
?>