<?php
/**
*
* @package phpBB3 Football
* @version $Id: ranks_total.php 1 2010-05-17 22:09:43Z football $
* @copyright (c) 2010 football (http://football.bplaced.net)
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

if ( !defined('IN_PHPBB') OR !defined('IN_FOOTBALL') )
{
	exit;
}

$start = request_var('start', 0);
$win_user_most_hits = array();
$win_user_most_hits_away = array();
$season_wins = array();
$win_user_most_hits = win_user_most_hits($season, $league, $matchday);
$win_user_most_hits_away = win_user_most_hits_away($season, $league, $matchday);

// Statistics  
$sql = "SELECT
			b.user_id,
			COUNT(b.match_no) AS matches,
			SUM(IF(b.goals_home <> '' AND b.goals_guest <> '', 1, 0)) AS bets,
			SUM(IF(b.goals_home <> '' AND b.goals_guest <> '',
					IF((b.goals_home < b.goals_guest) <> (m.goals_home < m.goals_guest) 
						OR (b.goals_home = b.goals_guest) <> (m.goals_home = m.goals_guest) 
						OR (b.goals_home > b.goals_guest) <> (m.goals_home > m.goals_guest),
						0,
						IF((b.goals_home = m.goals_home) AND (b.goals_guest = m.goals_guest), 0, 1)
					),
					0
				)
			) AS tendency
		FROM " . FOOTB_BETS . ' AS b
		LEFT JOIN ' . FOOTB_MATCHES . " AS m ON (m.season = b.season AND m.league = b.league AND m.match_no = b.match_no)
		WHERE b.season = $season 
			AND b.league = $league 
			AND m.status IN (2,3) 
			AND m.matchday <= $matchday
		GROUP BY user_id";

$result = $db->sql_query($sql);
$rows = $db->sql_fetchrowset($result);
$total_users = sizeof($rows);
$db->sql_freeresult($result);

foreach ($rows AS $row)
{
	$bets_of[$row['user_id']] 		= $row['bets'];
	$nobets_of[$row['user_id']] 	= $row['matches'] - $row['bets'];
	$tendency_of[$row['user_id']] 	= $row['tendency'];
}

$data_ranks = false;
$pagination = '';

$prev_rank_of = array();
if ($matchday > 1)
{
	// previous rank total 
	$sql = 'SELECT
			rank_total,
			user_id
		FROM '. FOOTB_RANKS . "
		WHERE season = $season 
			AND league = $league 
			AND matchday = ($matchday-1) 
			AND status IN (2,3)
		ORDER BY rank_total ASC, user_id ASC";
	$result = $db->sql_query($sql);
	$rows = $db->sql_fetchrowset($result);
	$db->sql_freeresult($result);

	foreach ($rows AS $row)
	{
		$prev_rank_of[$row['user_id']] = $row['rank_total'];
	}
}

$sql = 'SELECT
			r.user_id,
			u.username,
			MIN(r.status) AS status_min,
			SUM(points) AS points,
			SUM(win) AS wins_total
		FROM '. FOOTB_RANKS . ' AS r
		LEFT JOIN '. USERS_TABLE . " AS u ON (r.user_id = u.user_id)
		WHERE r.season = $season 
			AND r.league = $league 
			AND r.matchday <= $matchday 
			AND r.status IN (2,3)
		GROUP BY user_id
		ORDER BY points DESC, user_id ASC";
$result = $db->sql_query($sql);

$ranking_arr = array();
while( $row = $db->sql_fetchrow($result))
{
	$ranking_arr[$row['user_id']] = $row;
}
$db->sql_freeresult($result);

if ( sizeof($ranking_arr) > 0 )
{
	if ($matchday == $maxmatchday)
	{
		$season_wins = season_wins($season, $league, $matchday);
		$sql = 'SELECT
					eb.user_id,
					SUM(eb.bet_points) AS points
				FROM  ' . FOOTB_EXTRA . ' AS e
				INNER JOIN ' . FOOTB_EXTRA_BETS . " AS eb ON (eb.season = e.season and eb.league = e.league and eb.extra_no = e.extra_no)
				WHERE e.matchday <> $matchday 
					AND e.matchday_eval = $matchday 
					AND e.extra_status > 1
				GROUP BY eb.user_id"; 
		
		$result = $db->sql_query($sql);
		while( $row = $db->sql_fetchrow($result))
		{
			$ranking_arr[$row['user_id']]['points'] += $row['points'];
		}
		$db->sql_freeresult($result);
	}
	// sort the ranking by points
	usort($ranking_arr, '_sort_points');
}



// Make sure $start is set to the last page if it exceeds the amount
if ($start < 0 || $start >= $total_users)
{
	$index_start = ($start < 0) ? 0 : floor(($total_users - 1) / $config['football_users_per_page']) * $config['football_users_per_page'];
}
else
{
	$index_start = floor($start / $config['football_users_per_page']) * $config['football_users_per_page'];
}
$index_end = $index_start + $config['football_users_per_page'] - 1;

// If we've got a hightlight set pass it on to pagination.
$pagination = generate_pagination(append_sid("{$phpbb_root_path}football.$phpEx?side=ranks_total", "m=$season&amp;l=$league&amp;m=$matchday"), $total_users, $config['football_users_per_page'], $start);


$index = 0;
$data_rank_total = false;
$last_rank = 0;
$last_points = -1;
foreach ($ranking_arr AS $curr_rank)
{
	$data_ranks = true;
	if ( $curr_rank['points'] == $last_points)
	{
		$rank = $last_rank;
	}
	else
	{
		$rank = $index + 1;
		$last_points = $curr_rank['points'];
		$last_rank = $rank;
	}
	
	if (($index_start <= $index) && ($index <= $index_end))
	{
		// Display page
		if (isset($prev_rank_of[$curr_rank['user_id']]))
		{
			if ($rank == $prev_rank_of[$curr_rank['user_id']])
			{
				$change_sign 	= '=';
				$change_img 	= "<img src=\"" . $phpbb_root_path . "football/images/no_change.gif\" alt=\"" . $user->lang['NO_CHANGES'] . "\"/>";
				$change_differ 	= '';
			}
			else
			{
				if ($rank > $prev_rank_of[$curr_rank['user_id']])
				{
					$change_sign 	= '+';
					$change_img 	= "<img src=\"" . $phpbb_root_path . "football/images/arrow_down.gif\" alt=\"" . $user->lang['WORSENED'] . "\"/>";
					$differ 		= $rank - $prev_rank_of[$curr_rank['user_id']];
					$change_differ 	= ' (' . $differ . ')';
				}
				else
				{
					$change_sign 	= '-';
					$change_img 	= "<img src=\"" . $phpbb_root_path . "football/images/arrow_up.gif\" alt=\""	. $user->lang['IMPROVED'] . "\"/>";
					$differ 		= $prev_rank_of[$curr_rank['user_id']] - $rank;
					$change_differ 	= ' (' . $differ . ')';
				}
			}
		}
		else
		{
			$change_sign 	= '';
			$change_img 	= '';
			$change_differ 	= '';
		}

		if ($matchday == $maxmatchday)
		{
			// if someone didn't bet the hole Season
			if(!isset($win_user_most_hits[$curr_rank['user_id']]["Win"]))
			{
				$win_user_most_hits[$curr_rank['user_id']]["Win"] = 0;
			}
			if(!isset($win_user_most_hits_away[$curr_rank['user_id']]["Win"]))
			{
				$win_user_most_hits_away[$curr_rank['user_id']]["Win"] = 0;
			}
			if(!isset($season_wins[$curr_rank['user_id']]["Win"]))
			{
				$season_wins[$curr_rank['user_id']]["Win"] = 0;
			}
			$win_total = sprintf('%01.2f',$curr_rank['wins_total'] + $win_user_most_hits[$curr_rank['user_id']]["Win"] + $win_user_most_hits_away[$curr_rank['user_id']]["Win"] + $season_wins[$curr_rank['user_id']]["Win"]);
		}
		else
		{
			$win_total = sprintf('%01.2f',$curr_rank['wins_total']);
		}
		if(!isset($win_user_most_hits[$curr_rank['user_id']]["direct_hit"]))
		{
			$win_user_most_hits[$curr_rank['user_id']]["direct_hit"] = 0;
		}
		if(!isset($win_user_most_hits_away[$curr_rank['user_id']]["direct_hit"]))
		{
			$win_user_most_hits_away[$curr_rank['user_id']]["direct_hit"] = 0;
		}
		$row_class = (!($index % 2)) ? 'bg1 row_light' : 'bg2 row_dark';
		if ($curr_rank['user_id'] == $user->data['user_id'])
		{
			$row_class = 'bg3  row_user';
		}
		$colorstyle = color_style($curr_rank['status_min']);

		$template->assign_block_vars('rankstotal', array(
			'ROW_CLASS' 	=> $row_class,
			'RANK' 			=> $rank,
			'CHANGE_SIGN' 	=> $change_sign,
			'CHANGE_IMG' 	=> $change_img,
			'CHANGE_DIFFER'	=> $change_differ,
			'USERID' 		=> $curr_rank['user_id'],
			'USERNAME' 		=> $curr_rank['username'],
			'URL' 			=> $phpbb_root_path . 'profile.php?mode=viewprofile&u=' . $curr_rank['user_id'],
			'BETS' 			=> $bets_of[$curr_rank['user_id']],
			'NOBETS' 		=> ($nobets_of[$curr_rank['user_id']] == 0) ? '&nbsp;' : $nobets_of[$curr_rank['user_id']],
			'TENDENCIES'	=> ($tendency_of[$curr_rank['user_id']] == 0) ? '&nbsp;' : $tendency_of[$curr_rank['user_id']],
			'DIRECTHITS' 	=> ($win_user_most_hits[$curr_rank['user_id']]["direct_hit"] == 0) ? '&nbsp;' : $win_user_most_hits[$curr_rank['user_id']]["direct_hit"],
			'DIRECTHITS2' 	=> ($win_user_most_hits_away[$curr_rank['user_id']]["direct_hit"] == 0) ? '&nbsp;' : $win_user_most_hits_away[$curr_rank['user_id']]["direct_hit"],
			'POINTS' 		=> $curr_rank['points'],
			'COLOR_STYLE'	=> $colorstyle,
			'WIN' 			=> $win_total,
			)
		);
	}
	$index++;
}
$db->sql_freeresult($result);

$sidename = sprintf($user->lang['RANK_TOTAL']);
$league_info = league_info($season, $league);
$template->assign_vars(array(
	'S_DISPLAY_RANKS_TOTAL'		=> true,
	'S_DATA_RANKS' 				=> $data_ranks,
	'S_SIDENAME' 				=> $sidename,
	'U_LEFT' 					=> append_sid("football.$phpEx", $u_footb_parm . 'side=ranks_matchday'),
	'LEFT_LINK' 				=> '&lt; ' . sprintf($user->lang['RANK_MATCHDAY']),
	'U_RIGHT' 					=> ($google == 1) ? '' : append_sid("football.$phpEx", $u_footb_parm . 'side=my_bets'),
	'RIGHT_LINK' 				=> ($google == 1) ? '&nbsp;' : sprintf($user->lang['MY_BETS']) . ' &gt;',
	'LEFT_TITLE' 				=> sprintf($user->lang['TITLE_RANK_MATCHDAY']),
	'RIGHT_TITLE' 				=> sprintf($user->lang['TITLE_MY_BETS']),
	'PAGINATION' 				=> $pagination,
	'PAGE_NUMBER' 				=> on_page($total_users, $config['football_users_per_page'], $start),
	'TOTAL_USERS'				=> ($total_users == 1) ? $user->lang['VIEW_BET_USER'] : sprintf($user->lang['VIEW_BET_USERS'], $total_users),
	'S_WIN' 					=> ($league_info['win_matchday'] == '0' and $league_info['win_season'] == '0') ? false : true,
	)
);
?>