<?php

/**
*
* @package Football
* @version $Id: bets_html.php 1 2010-05-17 22:09:43Z football $
* @copyright (c) 2010 football (http://football.bplaced.net)
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

if (!defined('IN_PHPBB'))
{
	exit;
}

$sqlmatches = 'SELECT
			m.formula_home,
			m.formula_guest,
			m.match_no,
			t1.team_id AS hid,
			t2.team_id AS gid,
			t1.team_name_short AS home_name,
			t2.team_name_short AS guest_name,
			m.goals_home,
			m.goals_guest,
			m.status
			FROM ' . FOOTB_MATCHES . ' AS m
			LEFT JOIN ' . FOOTB_TEAMS . ' AS t1 ON (t1.season = m.season AND t1.league = m.league AND t1.team_id=m.team_id_home)
			LEFT JOIN ' . FOOTB_TEAMS . " AS t2 ON (t2.season = m.season AND t2.league = m.league AND t2.team_id=m.team_id_guest)
			WHERE  m.season = $season AND m.league = $league AND m.matchday=$matchday
			ORDER BY m.match_datetime ASC,m.match_no ASC";
$resultmatches = $db->sql_query($sqlmatches);
$rows_matches = $db->sql_fetchrowset($resultmatches);
$countmatches = sizeof($rows_matches);

$db->sql_freeresult($resultmatches);
$sqlbets = "SELECT
			u.username,
			b.goals_home AS bet_home,
			b.goals_guest AS bet_guest,
			m.status,
			IF(b.goals_home = '' OR b.goals_guest = '',0,1) AS tapped,
			" . select_points() . "
			FROM  " . FOOTB_MATCHES . ' AS m
			LEFT JOIN ' . FOOTB_BETS . ' AS b ON (b.season = m.season AND b.league = m.league AND b.match_no = m.match_no)
			LEFT JOIN  ' . USERS_TABLE. " AS u ON u.user_id=b.user_id
			WHERE  m.season = $season AND m.league = $league AND m.matchday=$matchday
			ORDER BY username ASC, match_datetime ASC, m.match_no ASC";

			
$resultbets = $db->sql_query($sqlbets);
$rows_bets = $db->sql_fetchrowset($resultbets);
$db->sql_freeresult($resultbets);
$countbets = sizeof($rows_bets);

$sqltendency = "SELECT
			m.match_no,
			MAX(m.status) as status,
			SUM(IF(b.goals_home > b.goals_guest AND b.goals_home <> '' AND b.goals_guest <> '',1,0)) AS win,
			SUM(IF(b.goals_home = b.goals_guest AND b.goals_home <> '' AND b.goals_guest <> '',1,0)) AS draw,
			SUM(IF(b.goals_home < b.goals_guest AND b.goals_home <> '' AND b.goals_guest <> '',1,0)) AS lost
			FROM  " . FOOTB_MATCHES . ' AS m
			LEFT JOIN ' . FOOTB_BETS . " AS b ON(b.season = m.season AND b.league = m.league AND b.match_no = m.match_no)
			WHERE m.season = $season AND m.league = $league AND  m.matchday=$matchday
			GROUP BY m.match_no
			ORDER BY match_datetime ASC, m.match_no ASC";

$resulttendency = $db->sql_query($sqltendency);
$rows_tendency = $db->sql_fetchrowset($resulttendency);
$db->sql_freeresult($resulttendency);
$counttendency = sizeof($rows_tendency);

$bets_html = "</td></tr></table><table border='0' cellpadding='2' cellspacing='0' class='tablebg'><tr>";
$bets_html .= "<th width='65'>". $newline . '</th>';
foreach ($rows_matches AS $row_matches)
{
	if (0 == $row_matches['hid'])
	{
		$home_info = get_team($season, $league, $row_matches['match_no'], 'team_id_home', $row_matches['formula_home']);
		$home_in_array = explode("#",$home_info);
		$home_name = $home_in_array[2];
	}
	else
	{
		$home_name = $row_matches['home_name'];
	}
	if (0 == $row_matches['gid'])
	{
		$guest_info = get_team($season, $league, $row_matches['match_no'], 'team_id_guest', $row_matches['formula_guest']);
		$guest_in_array = explode("#",$guest_info);
		$guest_name = $guest_in_array[2];
	}
	else
	{
		$guest_name = $row_matches['guest_name'];
	}
	$bets_html .= "<th colspan='4'>". $home_name .'<br />'. $guest_name . $newline . '</th>';
}
$bets_html .= '<th></th></tr>';
$bets_html .= "<tr><td width='65' class='row_result '><b>". sprintf($user->lang['RESULTS']). '<b>' . $newline . '</td>';

foreach ($rows_matches AS $row_matches)
{
	$bets_html .= "<td colspan='3'  align='center' class='row_result ". color_style($row_matches['status']). "'>". $row_matches['goals_home'] .':'. $row_matches['goals_guest']. $newline . "</td><td class='row_result'> </td>";
}
$bets_html .= "<td class='row_result'><b>". sprintf($user->lang['TOTAL']). '<b></td></tr>';

$class = 'firstline';

$j = 0; 
foreach ($rows_bets AS $row_bets)
{
	$status = $row_bets['status'];
	$points = $row_bets['points'];
	$points_style = '';

	if ($status < 1 && !$config['football_view_bets'])
	{
		// hide bets
		$bet_home = ($row_bets['bet_home'] == '') ? '&nbsp;' : '?';
		$bet_guest = ($row_bets['bet_guest'] == '') ? '&nbsp;' : '?';
	}
	else
	{
		$bet_home = $row_bets['bet_home'];
		$bet_guest = $row_bets['bet_guest'];
	}

	if ($status == 2 OR $status == 3 )
	{
		$mpoints = $points;
		if ($points == 0)
		{
			$points = '';
		}
		else
		{
			$points_style = color_style($status);
		}
	}
	else
	{
		$mpoints = 0;
		$points = '';
	}
	if(($j % $countmatches) == 0)
	{
		if($class == 'bg2 row_dark')
		{
			$class = 'bg1 row_light';
		}
		else
		{
			$class = 'bg2 row_dark';
		}
		$bets_html .= "<tr><td align='right' class='" . $class . "' width='65'>" . $row_bets['username'] . '</td>';
		$bets_html .= "<td align='right' class='" . $class . "'>" . $bet_home . '</td>';
		$bets_html .= "<td align='center' class='" . $class . "'>:</td>";
		$bets_html .= "<td align='left' class='" . $class . "'>". $bet_guest . '</td>';
		$bets_html .= "<td class='" . $class . ' ' . $points_style . "' width='15'>" . $points . $newline . '</td>';
		$tpoints = $mpoints;
		$minstatus = $status;
		$maxstatus = $status;
	}
	else
	{
		if ($minstatus > $status )
		{
			$minstatus = $status;
		}
		if ($maxstatus < $status )
		{
			$maxstatus = $status;
		}
		$tpoints += $mpoints;
		if(($j % $countmatches) == ($countmatches - 1))
		{
			$status = $maxstatus;
			if ($maxstatus >= 3 AND $minstatus < 3)
			{
				$status = 2;
			}
			$bets_html .= "<td align='right' class='". $class. "'>". $bet_home . '</td>';
			$bets_html .= "<td align='center' class='" . $class . "'>:</td>";
			$bets_html .= "<td align='left' class='" . $class . "'>" . $bet_guest . '</td>';
			$bets_html .= "<td class='" . $class . ' ' . $points_style . "' width='15'>" . $points . $newline . '</td>';
			$bets_html .= "<td class='" . $class . ' ' .color_style($status) . "' width='15'>" . $tpoints . $newline . '</td></tr>';
	    }
		else
		{
			$bets_html .= "<td align='right' class='" . $class . "'>" . $bet_home . '</td>';
			$bets_html .= "<td align='center' class='" . $class . "'>:</td>";
			$bets_html .= "<td align='left' class='" . $class . "'>" . $bet_guest . '</td>';
			$bets_html .= "<td class='" . $class . ' ' . $points_style . "' width='15'>". $points . $newline . '</td>';
	    }
	}
	$j++;
}

$bets_html .= "<tr><th align='left'>". sprintf($user->lang['TENDENCY']). $newline . '</th>';

foreach ($rows_tendency AS $row_tendency)
{
	if ($row_tendency['status'] < 1 && !$config['football_view_tendencies'])
	{
		// hide tendencies
		$bets_html .= "<th align='center' colspan=4>?-?-?". $newline . '</th>';
	}
	else
	{
		$bets_html .= "<th align='center' colspan=4>" . $row_tendency['win'] . '-' . $row_tendency['draw'] . '-' . $row_tendency['lost']. $newline . '</th>';
	}
}
$bets_html .= '<th> </th>';
$bets_html .= '</tr></table><table><tr><td>';

?>